# -*- coding: utf-8 -*-

import msvobj


class MSRMVObject(msvobj.MSVObject):
    def init_from_string(self,data):
        #Header 1
        self.extension=data[:4]
        #print "extension",self.extension
        data=data[4:]
        self.ftype=self.int_from_binstr(data[:2])
        #print "ftype",self.ftype
        data=data[2:]
        self.filesize=self.int_from_binstr(data[:4])
        #print "filesize",self.filesize
        data=data[4:]
        
        #Header 2
        if self.ftype==1:
            self.result_str_size=self.int_from_binstr(data[:2])
            #print "result_str_size",self.result_str_size
            data=data[2:]
            self.version_info_size=self.int_from_binstr(data[:2])
            #print "version_info_size",self.version_info_size
            data=data[2:]
            self.player_info_size=self.int_from_binstr(data[:2])
            #print "player_info_size",self.player_info_size
            data=data[2:]
            self.board_size=self.int_from_binstr(data[:2])
            #print "board_size",self.board_size
            data=data[2:]
            self.preflagged_size=self.int_from_binstr(data[:2])
            #print "preflagged_size",self.preflagged_size
            data=data[2:]
            self.properties_size=self.int_from_binstr(data[:2])
            #print "properties_size",self.properties_size
            data=data[2:]
            self.vid_size=self.int_from_binstr(data[:4])
            #print "vid_size",self.vid_size
            data=data[4:]
            self.checksum_size=self.int_from_binstr(data[:2])
            #print "checksum_size",self.checksum_size
            data=data[2:]
        else:
            return

        #result string
        self.result_str=data[:self.result_str_size]
        data=data[self.result_str_size:]

        #version information
        self.version_info=data[:self.version_info_size]
        #print "version_info",self.version_info
        data=data[self.version_info_size:]

        #player fields
        self.num_player_fields=self.int_from_binstr(data[:2])
        #print "num_player_fields",self.num_player_fields
        data=data[2:]
        player_fields=[]
        self.player_data={}
        for x in xrange(self.num_player_fields):
            field_size=self.int_from_binstr(data[:1])
            data=data[1:]
            player_fields.append(data[:field_size])
            data=data[field_size:]
        #print "player_fields",player_fields
        if self.num_player_fields>=1:
            self.player_data["name"]=player_fields[0]
        if self.num_player_fields>=2:
            self.player_data["nickname"]=player_fields[1]
        if self.num_player_fields>=3:
            self.player_data["country"]=player_fields[2]

        #board
        self.timestamp_boardgen=self.int_from_binstr(data[:4])
        #print "timestamp_boardgen",self.timestamp_boardgen
        data=data[4:]
        self.cols=self.int_from_binstr(data[:1])
        #print "cols",self.cols
        data=data[1:]
        self.rows=self.int_from_binstr(data[:1])
        #print "rows",self.rows
        data=data[1:]
        self.num_mines=self.int_from_binstr(data[:2])
        #print "num_mines",self.num_mines
        data=data[2:]
        self.mines=[]
        for x in xrange(self.num_mines):
            c=self.int_from_binstr(data[:1])
            data=data[1:]
            r=self.int_from_binstr(data[:1])
            data=data[1:]
            self.mines.append((c,r))
        #print self.mines

        #preflagged
        self.preflags=[]
        if self.preflagged_size:
            self.num_flags=self.int_from_binstr(data[:2])
            #print "num_flags",self.num_flags
            data=data[2:]
            for x in xrange(self.num_flags):
                col=self.int_from_binstr(data[:1])
                data=data[1:]
                row=self.int_from_binstr(data[:1])
                data=data[1:]
                self.preflags.append((row,col))
        #print "preflags",self.preflags

        #properties
        properties=[]
        self.properties={}
        for x in xrange(self.properties_size):
            properties.append(self.int_from_binstr(data[:1]))
            data=data[1:]
        self.properties["questionmarks"]=bool(properties[0])
        self.properties["nonflagging"]=bool(properties[1])
        modes={0: "normal",
                1: "UPK",
                2: "cheat",
                3: "density"}
        levels={0: "beginner",
                1: "intermediate",
                2: "expert",
                3: "custom"}
        try:
            self.properties["mode"]=modes[properties[2]]
        except KeyError:
            print "Warning: Illegal mode!"
        try:
            self.properties["level"]=levels[properties[3]]
        except KeyError:
            print "Warning: Illegal level!"

        self.events=[]

        metypes={1:"move",
                    2:"lmb_down",
                    3:"lmb_up",
                    4:"rmb_down",
                    5:"rmb_up",
                    6:"mmb_down",
                    7:"mmb_up"}
        betypes={9:"pressed",
                    10:"pressed_qm",
                    11:"closed",
                    12:"qm",
                    13:"flag",
                    14:"open",
                    18:"open_0",
                    19:"open_1",
                    20:"open_2",
                    21:"open_3",
                    22:"open_4",
                    23:"open_5",
                    24:"open_6",
                    25:"open_7",
                    26:"open_8",
                    27:"open_blast"}
        i=0
        while data:
            evcode=self.int_from_binstr(data[:1])
            data=data[1:]
            if evcode==0:
                tschdata=data[:4]
                data=data[4:]
                print "Warning, timestampchange is deprecated!"
                #print "timestampchange"
                ts=self.int_from_binstr(tschdata)
                self.events.append({"type":"tsch",
                                    "ts":ts})
            elif 1<=evcode<=7:
                medata=data[:8]
                data=data[8:]
                gametime=self.int_from_binstr(medata[:3])
                numflags=self.int_from_binstr(medata[3])
                xpos=self.int_from_binstr(medata[4:6])
                ypos=self.int_from_binstr(medata[6:8])
                #if ypos<100 or xpos<10:
                    #print "xy",xpos,ypos
                self.events.append({"type":"mouse",
                                    "subtype":metypes[evcode],
                                    "gametime":gametime,
                                    "numflags":numflags,
                                    "xpos":xpos-12, #@12,56 see below
                                    "ypos":ypos-56})
                            #compensate for vsweep offsetting these coords from
                            #the upper left corner of the window, or whatever
                            #(it is not the board, in any case)
            elif 9<=evcode<=14 or 18<=evcode<=27:
                col=self.int_from_binstr(data[0])
                row=self.int_from_binstr(data[1])
                data=data[2:]
                self.events.append({"type":"board",
                                    "subtype":betypes[evcode],
                                    "col":col,
                                    "row":row})
            elif 15<=evcode<=17:
                #print "game over"
                if evcode==15:
                    how="blast"
                if evcode==16:
                    how="win"
                if evcode==17:
                    how="other"
                self.events.append({"type":"terminate",
                                    "how":how})
                break
            else:
                print "wtf?!?"
            i+=1
        #print "5e",self.events[:5]
        self.timeth=self.int_from_binstr(data[:3])
        data=data[3:]
        self.checksum=data[:self.checksum_size]
        data=data[self.checksum_size:]
        #print i
        #print self.events

    def int_from_binstr(self,binstr):
        spow=len(binstr)-1
        res=0
        for char in binstr:
            res+=ord(char)*256**spow
            spow-=1
        return res

